diff -Naur -x .svn stamp-0.9.10/lib/htm_util.h stamp-0.9.10_Distribute/lib/htm_util.h
--- stamp-0.9.10/lib/htm_util.h	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/htm_util.h	2014-12-18 12:22:12.521692905 +0900
@@ -0,0 +1,193 @@
+/* Copyright (c) IBM Corp. 2014. */
+#ifndef _HTM_UTIL_H
+#define _HTM_UTIL_H
+
+#include <stdint.h>
+#if defined(__370__) && __COMPILER_VER__ >= 0x410d0000
+#include <builtins.h>
+#endif
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+typedef struct {
+#if defined(__370__)
+  uint8_t format;
+  uint8_t flags;
+  uint16_t reserved0;
+  uint16_t reserved1;
+  uint16_t transactionNestingDepth;
+  uint64_t transactionAbortCode;
+  uint64_t conflictToken;
+  uint64_t abortedTransactionInstructionAddress;
+  uint8_t EAID;
+  uint8_t DXC;
+  uint16_t reserved2;
+  uint32_t programInterruptionIdentification;
+  uint64_t translationExceptionIdentification;
+  uint64_t breakingEventAddress;
+  uint64_t reserved3[8];
+  uint32_t reserved4;
+  uint16_t reserved5;
+  uint8_t reserved6;
+  uint8_t LSUAbortCode;
+  uint64_t generalRegisters[16];
+#elif defined(__x86_64)
+  uint64_t transactionAbortCode;
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+  uint64_t transactionAbortCode;
+  uint64_t abortedTransactionInstructionAddress;
+#endif
+} TransactionDiagnosticInfo;
+
+/*
+  int tbegin(TransactionDiagnosticInfo *diag);
+  Returns 0 for success
+          1 for inderminate
+          2 for transient abort
+	  3 for persistent abort
+ */
+
+#if defined(__370__)
+
+int tbegin(TransactionDiagnosticInfo *diag);
+#if __COMPILER_VER__ >= 0x410d0000
+#define tend() __TM_end()
+#else
+void tend();
+#endif
+void ctend(volatile int64_t *addr);
+void tabort(uint64_t code);
+void tabort_no_abend_in_no_tx(uint64_t code);
+#if __COMPILER_VER__ >= 0x410d0000
+/* addr must be 8-byte aligned */
+#define non_tx_store(addr, data) __TM_non_transactional_store((addr), (long long)data)
+#else
+void non_tx_store(int64_t *addr, int64_t data);
+#endif
+#if __COMPILER_VER__ >= 0x410d0000
+#define get_transaction_nesting_depth() __TM_nesting_depth(NULL)
+#else
+int get_transaction_nesting_depth();
+#endif
+void save_preserved_fpr(uint64_t *addr);
+void restore_preserved_fpr(uint64_t *addr);
+
+#define NUM_HTM_FAILURE_REASONS 19
+
+#elif defined(__x86_64)
+
+#define XABORT_EXPLICIT	0x01
+#define XABORT_RETRY	0x02
+#define XABORT_CONFLICT	0x04
+#define XABORT_CAPACITY	0x08
+#define XABORT_DEBUG	0x10
+#define XABORT_NESTED	0x20
+
+static inline int tbegin(TransactionDiagnosticInfo *diag)
+{
+  int xbegin_result;
+
+  xbegin_result = 0xffffffff;
+  asm volatile("mov %0, %%eax;"
+	       ".byte 0xc7; .byte 0xf8; .int 0x00000000;" /* xbegin */
+	       "mov %%eax, %0"
+	       : "+r"(xbegin_result)
+	       :
+	       : "%eax");
+  if (xbegin_result == 0xffffffff)
+    return 0;
+  else {
+    diag->transactionAbortCode = xbegin_result;
+    if (xbegin_result & XABORT_RETRY)
+      return 2;
+    return 3;
+  }
+}
+
+#define tend() do {							\
+    asm volatile(".byte 0x0f; .byte 0x01; .byte 0xd5" :: ); /* xend */	\
+  } while (0)
+
+#define tabort(code) do {						\
+    asm volatile(".byte 0xc6; .byte 0xf8; .byte 0xff" :: ); /* xabort */ \
+  } while (0)
+
+#define NUM_HTM_FAILURE_REASONS 7
+
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+
+static inline int tbegin(TransactionDiagnosticInfo *diag)
+{
+  uint32_t tbegin_status;
+
+  asm volatile(".long 0x7c00051d;"
+	       "mfcr %0"
+	       :"=r"(tbegin_status): : "cr0");	// tbegin. 0
+  if (! (tbegin_status & 0x20000000U))
+    return 0;
+  else {
+#ifdef _ARCH_PPC64
+    uint64_t texasr;
+    uint64_t tfiar;
+
+    asm volatile("mfspr %0,130;"
+		 "mfspr %1,129"
+		 :"=r"(texasr), "=r"(tfiar): );
+    diag->transactionAbortCode = texasr;
+#else
+    uint32_t texasr;
+    uint32_t texasru;
+    uint32_t tfiar;
+
+    asm volatile("mfspr %0,130;"
+		 "mfspr %1,131;"
+		 "mfspr %2,129"
+		 :"=r"(texasr), "=r"(texasru), "=r"(tfiar): );
+    diag->transactionAbortCode = (uint64_t)texasru << 32 | (uint64_t)texasr;
+#endif
+    diag->abortedTransactionInstructionAddress = (uint64_t)tfiar & ~0x3ULL;
+    if (texasr & 0x0100000000000000ULL)
+      return 3;
+    return 2;
+  }
+}
+
+/* tend. 0 */
+#define tend() do {				\
+    asm volatile(".long 0x7c00055d":::"cr0" );	\
+  } while (0)
+
+static inline void tabort(uint64_t code)
+{
+  uint64_t int_code = code << 56;
+  asm volatile("mr 3,%0;"
+	       ".long 0x7c03071d": : "r" (int_code) : "r3", "cr0"); // tabort. 3
+  //asm(".long 0x7c00071d":::"cr0" ); // tabort. 0
+}
+
+#define tsuspend() do {				\
+    asm volatile (".long 0x7C0005DD");		\
+  } while (0)
+
+#define tresume() do {				\
+    asm volatile (".long 0x7C2005DD");		\
+  } while (0)
+
+#define NUM_HTM_FAILURE_REASONS 12
+
+#else
+
+#error
+
+#endif
+
+void countHTMFailures(TransactionDiagnosticInfo *diag, uint64_t *counters);
+const char *getHTMFailureName(int id);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* _HTM_UTIL_H */
diff -Naur -x .svn stamp-0.9.10/lib/map.h stamp-0.9.10_Distribute/lib/map.h
--- stamp-0.9.10/lib/map.h	2008-09-09 07:42:40.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/map.h	2014-12-18 12:22:19.447592848 +0900
@@ -68,6 +68,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #ifndef MAP_H
@@ -91,6 +92,26 @@
 #  define MAP_INSERT(map, key, data)  hashtable_insert(map, (void*)(key), (void*)(data))
 #  define MAP_REMOVE(map, key)        hashtable_remove(map, (void*)(key))
 
+#elif defined(MAP_USE_CONCUREENT_HASHTABLE)
+
+#  include "conc_hashtable.h"
+
+#  define MAP_T                       conc_hashtable_t
+#  define MAP_ALLOC(hash, cmp)        conc_hashtable_alloc(1, hash, cmp, 2, 2)
+#  define MAP_FREE(map)               conc_hashtable_free(map)
+#  define MAP_CONTAINS(map, key)      conc_hashtable_containsKey(map, (void*)(key))
+#  define MAP_FIND(map, key)          conc_hashtable_find(map, (void*)(key))
+#  define MAP_INSERT(map, key, data)  conc_hashtable_insert(map, (void*)(key), (void*)(data))
+#  define MAP_REMOVE(map, key)        conc_hashtable_remove(map, (void*)(key))
+
+#  define TMMAP_ALLOC(hash, cmp)      TMCONC_HASHTABLE_ALLOC(1, hash, cmp, 2, 2)
+#  define TMMAP_FREE(map)             TMCONC_HASHTABLE_FREE(map)
+#  define TMMAP_CONTAINS(map, key)    TMCONC_HASHTABLE_CONTAINSKEY(map, (void*)(key))
+#  define TMMAP_FIND(map, key)        TMCONC_HASHTABLE_FIND(map, (void*)(key))
+#  define TMMAP_INSERT(map, key, data) \
+    TMCONC_HASHTABLE_INSERT(map, (void*)(key), (void*)(data))
+#  define TMMAP_REMOVE(map, key)      TMCONC_HASHTABLE_REMOVE(map, (void*)(key))
+
 #elif defined(MAP_USE_ATREE)
 
 #  include "atree.h"
@@ -236,6 +257,10 @@
     rbtree_insert(map, (void*)(key), (void*)(data))
 #  define MAP_REMOVE(map, key)        rbtree_delete(map, (void*)(key))
 
+/* Added by Odaira begin */
+#  define TMMAP_ALLOC(hash, cmp)        TMRBTREE_ALLOC(cmp)
+#  define TMMAP_FREE(map)               TMRBTREE_FREE(map)
+/* Added by Odaira end */
 #  define TMMAP_CONTAINS(map, key)    TMRBTREE_CONTAINS(map, (void*)(key))
 #  define TMMAP_FIND(map, key)        TMRBTREE_GET(map, (void*)(key))
 #  define TMMAP_INSERT(map, key, data) \
diff -Naur -x .svn stamp-0.9.10/lib/memory.c stamp-0.9.10_Distribute/lib/memory.c
--- stamp-0.9.10/lib/memory.c	2008-09-09 07:42:40.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/memory.c	2014-12-18 12:22:26.524574097 +0900
@@ -68,10 +68,12 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
 #include <stdlib.h>
+#include <stdint.h>
 #include "memory.h"
 #include "types.h"
 
@@ -84,14 +86,24 @@
 #endif
 
 
+#ifdef __370__
+#define PADDING_SIZE 32
+#elif defined(__bgq__)
+#define PADDING_SIZE 16
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+#define PADDING_SIZE 16
+#elif defined(__x86_64__)
 #define PADDING_SIZE 8
+#else
+#define PADDING_SIZE 8
+#endif
 typedef struct block {
-    long padding1[PADDING_SIZE];
+    uint64_t padding1[PADDING_SIZE];
     size_t size;
     size_t capacity;
     char* contents;
     struct block* nextPtr;
-    long padding2[PADDING_SIZE];
+    uint64_t padding2[PADDING_SIZE];
 } block_t;
 
 typedef struct pool {
diff -Naur -x .svn stamp-0.9.10/lib/mfence.h stamp-0.9.10_Distribute/lib/mfence.h
--- stamp-0.9.10/lib/mfence.h	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/mfence.h	2014-12-18 12:22:31.301574036 +0900
@@ -0,0 +1,22 @@
+/* Copyright (c) IBM Corp. 2014. */
+
+#if defined(__x86_64__)
+#include <emmintrin.h>
+#endif
+/* requires C99 */
+static inline void memory_fence(void) {
+#if defined(__370__)
+    /* Nothing to do */
+#elif defined(__PPC__) && defined(__IBMC__)
+  __lwsync();
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+    asm volatile("lwsync" : : );
+#elif defined(__x86_64__)
+  _mm_sfence();
+#elif defined(__GNUC__) || defined(__IBMC__)
+    __sync_synchronize();
+#else
+#error
+#endif
+}
+
diff -Naur -x .svn stamp-0.9.10/lib/rbtree.c stamp-0.9.10_Distribute/lib/rbtree.c
--- stamp-0.9.10/lib/rbtree.c	2008-09-09 07:42:41.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/rbtree.c	2014-12-18 12:22:41.654707508 +0900
@@ -78,6 +78,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <string.h>
@@ -102,6 +103,9 @@
 struct rbtree {
     node_t* root;
     long (*compare)(const void*, const void*);   /* returns {-1,0,1}, 0 -> equal */
+#ifdef RBTREE_SIZE_FIELD
+    long size;
+#endif
 };
 
 #define LDA(a)              *(a)
@@ -1276,6 +1280,9 @@
     if (n) {
         n->compare = (compare ? compare : &compareKeysDefault);
         n->root = NULL;
+#ifdef RBTREE_SIZE_FIELD
+	n->size = 0;
+#endif
     }
     return n;
 }
@@ -1292,6 +1299,9 @@
     if (n){
         n->compare = (compare ? compare : &compareKeysDefault);
         n->root = NULL;
+#ifdef RBTREE_SIZE_FIELD
+	n->size = 0;
+#endif
     }
     return n;
 }
@@ -1412,6 +1422,11 @@
     if (ex != NULL) {
         releaseNode(node);
     }
+#ifdef RBTREE_SIZE_FIELD
+    if (ex == NULL) {
+	STF(r, size, LDF(r, size) + 1);
+    }
+#endif
     return ((ex == NULL) ? TRUE : FALSE);
 }
 
@@ -1429,6 +1444,11 @@
     if (ex != NULL) {
         TMreleaseNode(TM_ARG  node);
     }
+#ifdef RBTREE_SIZE_FIELD
+    if (ex == NULL) {
+	TX_STF(r, size, TX_LDF(r, size) + 1);
+    }
+#endif
     return ((ex == NULL) ? TRUE : FALSE);
 }
 
@@ -1448,6 +1468,9 @@
     }
     if (node != NULL) {
         releaseNode(node);
+#ifdef RBTREE_SIZE_FIELD
+	STF(r, size, LDF(r, size) - 1);
+#endif
     }
     return ((node != NULL) ? TRUE : FALSE);
 }
@@ -1468,6 +1491,9 @@
     }
     if (node != NULL) {
         TMreleaseNode(TM_ARG  node);
+#ifdef RBTREE_SIZE_FIELD
+	TX_STF(r, size, TX_LDF(r, size) - 1);
+#endif
     }
     return ((node != NULL) ? TRUE : FALSE);
 }
@@ -1565,6 +1591,189 @@
 }
 
 
+/* =============================================================================
+ * rbtree_get_root_key
+ * =============================================================================
+ */
+void *
+rbtree_get_root_key (rbtree_t *r)
+{
+    node_t* t = LDNODE(r, root);
+    return LDF(t, k);
+}
+
+
+/* =============================================================================
+ * TMrbtree_get_root_key
+ * =============================================================================
+ */
+TM_CALLABLE
+void *
+TMrbtree_get_root_key (TM_ARGDECL  rbtree_t* r)
+{
+    node_t* t = TX_LDNODE(r, root);
+    return TX_LDF_P(t, k);
+}
+
+
+#ifdef RBTREE_SIZE_FIELD
+/* =============================================================================
+ * rbtree_get_size
+ * =============================================================================
+ */
+long
+rbtree_get_size (rbtree_t *r)
+{
+    return LDF(r, size);
+}
+
+
+/* =============================================================================
+ * TMrbtree_get_root_key
+ * =============================================================================
+ */
+TM_CALLABLE
+long
+TMrbtree_get_size (TM_ARGDECL  rbtree_t* r)
+{
+    return TX_LDF(r, size);
+}
+#endif
+
+
+/* =============================================================================
+ * rbtree_iter_reset
+ * =============================================================================
+ */
+void
+rbtree_iter_reset (rbtree_iter_t* itPtr, rbtree_t* r)
+{
+    *itPtr = NULL;
+}
+
+
+/* =============================================================================
+ * TMrbtree_iter_reset
+ * =============================================================================
+ */
+TM_CALLABLE
+void
+TMrbtree_iter_reset (TM_ARGDECL  rbtree_iter_t* itPtr, rbtree_t* r)
+{
+    TM_LOCAL_WRITE_P(*itPtr, NULL);
+}
+
+
+/* =============================================================================
+ * rbtree_iter_hasNext
+ * =============================================================================
+ */
+bool_t
+rbtree_iter_hasNext (rbtree_iter_t* itPtr, rbtree_t* s)
+{
+    node_t* r;
+    if (*itPtr == NULL) {
+	*itPtr = LDNODE(s, root);
+	if (*itPtr == NULL) {
+	    return FALSE;
+	}
+	r = *itPtr;
+    } else {
+	r = LDNODE(*itPtr, r);
+    }
+    if (r == NULL) {
+	node_t* n;
+	n = *itPtr;
+	while (LDNODE(n, p) != NULL && LDNODE(LDNODE(n, p), r) == n) {
+	    n = LDNODE(n, p);
+	}
+	if (LDNODE(n, p) == NULL) {
+	    return FALSE;
+	} else {
+	    *itPtr = LDNODE(n, p);
+	    return TRUE;
+	}
+    } else {
+	while (LDNODE(r, l) != NULL) {
+	    r = LDNODE(r, l);
+	}
+	*itPtr = r;
+	return TRUE;
+    }
+}
+
+
+/* =============================================================================
+ * TMrbtree_iter_hasNext
+ * =============================================================================
+ */
+TM_CALLABLE
+bool_t
+TMrbtree_iter_hasNext (TM_ARGDECL  rbtree_iter_t* itPtr, rbtree_t* s)
+{
+    node_t* r;
+    if (*itPtr == NULL) {
+	TM_LOCAL_WRITE_P(*itPtr, TX_LDNODE(s, root));
+	if (*itPtr == NULL) {
+	    return FALSE;
+	}
+	r = *itPtr;
+    } else {
+	r = TX_LDNODE(*itPtr, r);
+    }
+    if (r == NULL) {
+	node_t* n;
+	n = *itPtr;
+	while (TX_LDNODE(n, p) != NULL && TX_LDNODE(TX_LDNODE(n, p), r) == n) {
+	    n = TX_LDNODE(n, p);
+	}
+	if (TX_LDNODE(n, p) == NULL) {
+	    return FALSE;
+	} else {
+	    TM_LOCAL_WRITE_P(*itPtr, TX_LDNODE(n, p));
+	    return TRUE;
+	}
+    } else {
+	while (TX_LDNODE(r, l) != NULL) {
+	    r = TX_LDNODE(r, l);
+	}
+	TM_LOCAL_WRITE_P(*itPtr, r);
+	return TRUE;
+    }
+}
+
+
+/* =============================================================================
+ * rbtree_iter_next
+ * =============================================================================
+ */
+void*
+rbtree_iter_next (rbtree_iter_t* itPtr, rbtree_t* r)
+{
+    if (*itPtr == NULL) {
+	return NULL;
+    } else {
+	return LDF(*itPtr, v);
+    }
+}
+
+
+/* =============================================================================
+ * TMrbtree_iter_next
+ * =============================================================================
+ */
+TM_CALLABLE
+void*
+TMrbtree_iter_next (TM_ARGDECL  rbtree_iter_t* itPtr, rbtree_t* r)
+{
+    if (*itPtr == NULL) {
+	return NULL;
+    } else {
+	return TX_LDF_P(*itPtr, v);
+    }
+}
+
+
 /* /////////////////////////////////////////////////////////////////////////////
  * TEST_RBTREE
  * /////////////////////////////////////////////////////////////////////////////
diff -Naur -x .svn stamp-0.9.10/lib/rbtree.h stamp-0.9.10_Distribute/lib/rbtree.h
--- stamp-0.9.10/lib/rbtree.h	2008-09-09 07:42:41.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/rbtree.h	2014-12-18 12:22:48.490756659 +0900
@@ -78,6 +78,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #ifndef RBTREE_H
@@ -94,6 +95,7 @@
 
 
 typedef struct rbtree rbtree_t;
+typedef struct node* rbtree_iter_t;
 
 
 /* =============================================================================
@@ -225,13 +227,112 @@
 TMrbtree_contains (TM_ARGDECL  rbtree_t* r, void* key);
 
 
-#define TMRBTREE_ALLOC()          TMrbtree_alloc(TM_ARG_ALONE)
+/* =============================================================================
+ * rbtree_get_root_key
+ * =============================================================================
+ */
+void*
+rbtree_get_root_key (rbtree_t* r);
+
+
+/* =============================================================================
+ * TMrbtree_get_root_key
+ * =============================================================================
+ */
+TM_CALLABLE
+void*
+TMrbtree_get_root_key (TM_ARGDECL  rbtree_t* r);
+
+
+#ifdef RBTREE_SIZE_FIELD
+/* =============================================================================
+ * rbtree_get_size
+ * =============================================================================
+ */
+long
+rbtree_get_size (rbtree_t* r);
+
+
+/* =============================================================================
+ * TMrbtree_get_root_key
+ * =============================================================================
+ */
+TM_CALLABLE
+long
+TMrbtree_get_size (TM_ARGDECL  rbtree_t* r);
+#endif
+
+
+/* Fixed by Odaira begin */ 
+#define TMRBTREE_ALLOC(r)          TMrbtree_alloc(TM_ARG  r)
+/*#define TMRBTREE_ALLOC()          TMrbtree_alloc(TM_ARG_ALONE)*/
+/* Fixed by Odaira end */ 
 #define TMRBTREE_FREE(r)          TMrbtree_free(TM_ARG  r)
 #define TMRBTREE_INSERT(r, k, v)  TMrbtree_insert(TM_ARG  r, (void*)(k), (void*)(v))
 #define TMRBTREE_DELETE(r, k)     TMrbtree_delete(TM_ARG  r, (void*)(k))
 #define TMRBTREE_UPDATE(r, k, v)  TMrbtree_update(TM_ARG  r, (void*)(k), (void*)(v))
 #define TMRBTREE_GET(r, k)        TMrbtree_get(TM_ARG  r, (void*)(k))
 #define TMRBTREE_CONTAINS(r, k)   TMrbtree_contains(TM_ARG  r, (void*)(k))
+#define TMRBTREE_GET_ROOT_KEY(r)  TMrbtree_get_root_key(TM_ARG  r)
+#ifdef RBTREE_SIZE_FIELD
+#define TMRBTREE_GET_SIZE(r)      TMrbtree_get_size(TM_ARG  r)
+#endif
+
+
+/* =============================================================================
+ * rbtree_iter_reset
+ * =============================================================================
+ */
+void
+rbtree_iter_reset (rbtree_iter_t* itPtr, rbtree_t* r);
+
+
+/* =============================================================================
+ * TMrbtree_iter_reset
+ * =============================================================================
+ */
+TM_CALLABLE
+void
+TMrbtree_iter_reset (TM_ARGDECL  rbtree_iter_t* itPtr, rbtree_t* r);
+
+
+/* =============================================================================
+ * rbtree_iter_hasNext
+ * =============================================================================
+ */
+bool_t
+rbtree_iter_hasNext (rbtree_iter_t* itPtr, rbtree_t* r);
+
+
+/* =============================================================================
+ * TMrbtree_iter_hasNext
+ * =============================================================================
+ */
+TM_CALLABLE
+bool_t
+TMrbtree_iter_hasNext (TM_ARGDECL  rbtree_iter_t* itPtr, rbtree_t* r);
+
+
+/* =============================================================================
+ * rbtree_iter_next
+ * =============================================================================
+ */
+void*
+rbtree_iter_next (rbtree_iter_t* itPtr, rbtree_t* r);
+
+
+/* =============================================================================
+ * TMrbtree_iter_next
+ * =============================================================================
+ */
+TM_CALLABLE
+void*
+TMrbtree_iter_next (TM_ARGDECL  rbtree_iter_t* itPtr, rbtree_t* r);
+
+
+#define TMRBTREE_ITER_RESET(it, r)      TMrbtree_iter_reset(TM_ARG  it, r)
+#define TMRBTREE_ITER_HASNEXT(it, r)    TMrbtree_iter_hasNext(TM_ARG  it, r)
+#define TMRBTREE_ITER_NEXT(it, r)       TMrbtree_iter_next(TM_ARG  it, r)
 
 
 #ifdef __cplusplus
diff -Naur -x .svn stamp-0.9.10/lib/thread.c stamp-0.9.10_Distribute/lib/thread.c
--- stamp-0.9.10/lib/thread.c	2008-09-09 07:42:41.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/thread.c	2014-12-18 12:22:53.988581669 +0900
@@ -67,14 +67,16 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
+#include <stdio.h>
 #include <assert.h>
 #include <stdlib.h>
 #include "thread.h"
 #include "types.h"
 
-static THREAD_LOCAL_T    global_threadId;
+static THREAD_KEY_T    global_threadId;
 static long              global_numThread       = 1;
 static THREAD_BARRIER_T* global_barrierPtr      = NULL;
 static long*             global_threadIds       = NULL;
@@ -83,6 +85,13 @@
 static void            (*global_funcPtr)(void*) = NULL;
 static void*             global_argPtr          = NULL;
 static volatile bool_t   global_doShutdown      = FALSE;
+#ifdef GLOBAL_LOCK
+#ifdef USE_MUTEX
+THREAD_MUTEX_T global_lock;
+#else
+volatile int global_lock;
+#endif
+#endif
 
 
 /* =============================================================================
@@ -95,7 +104,7 @@
 {
     long threadId = *(long*)argPtr;
 
-    THREAD_LOCAL_SET(global_threadId, (long)threadId);
+    THREAD_KEY_SET(global_threadId, (long)threadId);
 
     while (1) {
         THREAD_BARRIER(global_barrierPtr, threadId); /* wait for start parallel */
@@ -125,6 +134,12 @@
     global_numThread = numThread;
     global_doShutdown = FALSE;
 
+#ifdef GLOBAL_LOCK
+#ifdef USE_MUTEX
+    THREAD_MUTEX_INIT(global_lock);
+#endif
+#endif
+
     /* Set up barrier */
     assert(global_barrierPtr == NULL);
     global_barrierPtr = THREAD_BARRIER_ALLOC(numThread);
@@ -132,7 +147,7 @@
     THREAD_BARRIER_INIT(global_barrierPtr, numThread);
 
     /* Set up ids */
-    THREAD_LOCAL_INIT(global_threadId);
+    THREAD_KEY_INIT(global_threadId);
     assert(global_threadIds == NULL);
     global_threadIds = (long*)malloc(numThread * sizeof(long));
     assert(global_threadIds);
@@ -221,7 +236,11 @@
 
     assert(numThread > 0);
     assert((numThread & (numThread - 1)) == 0); /* must be power of 2 */
+#ifdef USE_SPIN_BARRIER
+    barrierPtr = (thread_barrier_t *)malloc(sizeof(thread_barrier_t));
+#else
     barrierPtr = (thread_barrier_t*)malloc(numThread * sizeof(thread_barrier_t));
+#endif
     if (barrierPtr != NULL) {
         barrierPtr->numThread = numThread;
     }
@@ -248,6 +267,13 @@
 void
 thread_barrier_init (thread_barrier_t* barrierPtr)
 {
+#ifdef USE_SPIN_BARRIER
+    barrierPtr->reachBarrier = barrierPtr->numThread;
+    barrierPtr->leaveBarrier = barrierPtr->numThread;
+    barrierPtr->reachBarrierFlag = 1;
+    barrierPtr->leaveBarrierFlag = 0;
+    /*barrierPtr->debugCounter = 0;*/
+#else
     long i;
     long numThread = barrierPtr->numThread;
 
@@ -257,8 +283,42 @@
         THREAD_COND_INIT(barrierPtr[i].proceedCond);
         THREAD_COND_INIT(barrierPtr[i].proceedAllCond);
     }
+#endif
 }
 
+#ifdef USE_SPIN_BARRIER
+static int32_t
+decrement_and_get(volatile int32_t *ptr)
+{
+#if defined(__370__)
+    int32_t local_value;
+    int32_t new_value;
+    local_value = *ptr;
+    do {
+	new_value = local_value - 1;
+    } while (cs((cs_t *)&local_value, (cs_t *)ptr, *(cs_t *)&new_value));
+
+    return new_value;
+    /*
+#elif defined(__GNUC__) && defined(__x86_64__)
+    return __atomic_sub_fetch(ptr,1,__ATOMIC_SEQ_CST);
+    */
+#elif defined(__GNUC__)
+    int32_t local_value;
+    int32_t new_value;
+    do {
+      local_value = *ptr;
+      new_value = local_value - 1;
+    } while (! __sync_bool_compare_and_swap(ptr, local_value, new_value));
+
+    return new_value;
+#elif defined(__IBMC__)
+    return __sync_sub_and_fetch(ptr,1);
+#else
+#error
+#endif
+}
+#endif
 
 /* =============================================================================
  * thread_barrier
@@ -268,6 +328,33 @@
 void
 thread_barrier (thread_barrier_t* barrierPtr, long threadId)
 {
+#ifdef USE_SPIN_BARRIER
+    /*fprintf(stderr, "Entering barrier %d: %ld\n", barrierPtr->debugCounter, threadId);*/
+    while (barrierPtr->leaveBarrierFlag == 1)
+	;
+    if (decrement_and_get(&barrierPtr->reachBarrier) == 0) {
+	/*barrierPtr->debugCounter++;*/
+	barrierPtr->reachBarrier = barrierPtr->numThread;
+	barrierPtr->leaveBarrierFlag = 1;
+#if !defined(__370__) && (defined(__GNUC__) || defined(__IBMC__))
+	__sync_synchronize();
+#endif
+	barrierPtr->reachBarrierFlag = 0;
+    } else {
+	while (barrierPtr->reachBarrierFlag == 1)
+	    ;
+    }
+
+    if (decrement_and_get(&barrierPtr->leaveBarrier) == 0) {
+	barrierPtr->leaveBarrier = barrierPtr->numThread;
+	barrierPtr->reachBarrierFlag = 1;
+#if !defined(__370__) && (defined(__GNUC__) || defined(__IBMC__))
+	__sync_synchronize();
+#endif
+	barrierPtr->leaveBarrierFlag = 0;
+    }
+    /*fprintf(stderr, "Exiting barrier %d: %ld\n", barrierPtr->debugCounter - 1, threadId);*/
+#else
     long i = 2;
     long base = 0;
     long index;
@@ -313,6 +400,7 @@
         THREAD_COND_SIGNAL(barrierPtr[index].proceedAllCond);
         THREAD_MUTEX_UNLOCK(barrierPtr[index].countLock);
     }
+#endif
 }
 
 
@@ -324,7 +412,7 @@
 long
 thread_getId()
 {
-    return (long)THREAD_LOCAL_GET(global_threadId);
+    return (long)THREAD_KEY_GET(global_threadId);
 }
 
 
diff -Naur -x .svn stamp-0.9.10/lib/thread.h stamp-0.9.10_Distribute/lib/thread.h
--- stamp-0.9.10/lib/thread.h	2008-09-09 07:42:41.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/thread.h	2014-12-18 12:23:00.773580506 +0900
@@ -67,6 +67,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #ifndef THREAD_H
@@ -75,6 +76,7 @@
 
 #include <pthread.h>
 #include <stdlib.h>
+#include <stdint.h>
 #include "types.h"
 #ifdef OTM
 #include "omp.h"
@@ -95,10 +97,10 @@
                                                            (void* (*)(void*))(fn), \
                                                            (void*)(arg))
 
-#define THREAD_LOCAL_T                      pthread_key_t
-#define THREAD_LOCAL_INIT(key)              pthread_key_create(&key, NULL)
-#define THREAD_LOCAL_SET(key, val)          pthread_setspecific(key, (void*)(val))
-#define THREAD_LOCAL_GET(key)               pthread_getspecific(key)
+#define THREAD_KEY_T                      pthread_key_t
+#define THREAD_KEY_INIT(key)              pthread_key_create(&key, NULL)
+#define THREAD_KEY_SET(key, val)          pthread_setspecific(key, (void*)(val))
+#define THREAD_KEY_GET(key)               pthread_getspecific(key)
 
 #define THREAD_MUTEX_T                      pthread_mutex_t
 #define THREAD_MUTEX_INIT(lock)             pthread_mutex_init(&(lock), NULL)
@@ -125,6 +127,17 @@
 #  define THREAD_BARRIER_FREE(bar)          thread_barrier_free(bar)
 #endif /* !SIMULATOR */
 
+#define USE_SPIN_BARRIER
+#ifdef USE_SPIN_BARRIER
+typedef struct thread_barrier {
+  volatile int32_t reachBarrier;
+  volatile int32_t leaveBarrier;
+  volatile int reachBarrierFlag;
+  volatile int leaveBarrierFlag;
+  int32_t numThread;
+  /*volatile int debugCounter;*/
+} thread_barrier_t;
+#else
 typedef struct thread_barrier {
     THREAD_MUTEX_T countLock;
     THREAD_COND_T proceedCond;
@@ -132,6 +145,7 @@
     long count;
     long numThread;
 } thread_barrier_t;
+#endif
 
 
 /* =============================================================================
@@ -223,6 +237,15 @@
 void
 thread_barrier_wait();
 
+#ifdef GLOBAL_LOCK
+#define USE_MUTEX
+
+#ifdef USE_MUTEX
+extern THREAD_MUTEX_T global_lock;
+#else
+extern volatile int global_lock;
+#endif
+#endif
 
 #ifdef __cplusplus
 }
